#{extends 'border.html'/}
<div id="activity_pane"></div>
<div class="container">
#{form @katalog.PermohonanPembaruanCtr.editSubmitProdukStagingHarga(), method:'POST', class:'form-horizontal save', enctype:'multipart/form-data'}
    <div class="row">
        <div class="col-md-12">
            <!-- Breadcrumb -->
            <ol class="breadcrumb">
                <li><a href="@{PublikCtr.home()}">&{'beranda.label'}</a></li>
                <li><a href="@{katalog.PermohonanPembaruanCtr.index()}">&{'permohonan_pembaruan.label'}</a></li>
                <li class="active">&{'edit.label'} &{'data.label'} &{'harga_produk.label'}</li>
            </ol>
            <!-- End Breadcrumb -->
        </div>
    </div>

    <!-- Toolbar -->
    <div class="row">
        <div class="col-md-12">
            <div class="toolbar">
                #{backButton action:@katalog.PermohonanPembaruanCtr.index()/}
                #{saveButton/}
            </div>

        </div>
    </div>
    <!-- End Toolbar -->

    <div class="row">
        #{alert /}
        <div class="alert-container"></div>
        <div class="panel panel-default">
            <div class="panel-body">
                <div class="row">
                    <div class="form-group">
                        <label class="col-sm-2 control-label">&{'penyedia.label'}</label>
                        <div class="col-sm-4">
                            <p id="namaPenyedia">${user.nama_lengkap}</p>
                        </div>
                    </div>
                    <div class="form-group required">
                        <label class="col-sm-2 control-label">&{'nama_produk.label'}</label>
                        <div class="col-sm-4">
                            <input type="hidden" id="namaProduk" value="${produk?.nama_produk}" name="namaProduk"/>
                            <input type="text" class="form-control" value="${produk?.nama_produk}" readonly/>
                        </div>
                        <div id="loadingName" class="col-sm-2" hidden="hidden">
                            <div class="loader"></div>
                        </div>
                    </div>

                    <div class="form-group required">
                        <label class="col-sm-2 control-label">&{'kurs.label'}</label>
                        <div class="col-sm-4">
                            <select required class="form-control" disabled="disabled">
                                <option value="">&{'pilih.label'}</option>
                                #{list kursList, as:'kl' }
                                    <option value="${kl.id}" ${produk?.harga_kurs_id == null ? (kl.nama_kurs == "IDR" ? "selected" : "") : (produk?.harga_kurs_id == kl.id ? "selected" : "")}>${kl.nama_kurs}</option>
                                #{/list}
                            </select>
                            <input type="hidden" name="produk.harga_kurs_id" value="${produk?.harga_kurs_id == null ? kur.id : produk?.harga_kurs_id}" />
                        </div>
                    </div>

                    <div class="form-group required" >
                        <label class="col-sm-2 control-label">&{'tanggal_harga.label'}</label>
                        <div class="col-sm-4">
                            <input maxlength="100" type="text" name="model.tanggal_harga"
                                   value="${produk?.getPriceDateString()}"
                                   class="form-control datepicker" data-date-end-date="0d" required/>
                        </div>
                    </div>

                    #{if komoditas.isNational()}
                        #{list atributHargaList, as:'harga'}
                            <div class="form-group required">
                                <label class="col-sm-2 control-label">${harga.label_harga}</label>
                                <div class="col-sm-4">
                                    <input onchange="bandingkanHarga()" type="text" id="${(harga.label_harga).replaceAll("\\s", "")}" value="${produk.id == null ? 0 : produk.getHargaByAttr(harga.id, listProdukHarga)}" required name="model.price[${harga_index - 1}].value" class="form-control product-price"/>
                                    <input type="hidden" value="${harga.id}" name="model.price[${harga_index - 1}].atribut_id"/>
                                    <input type="hidden" value="${harga.apakah_harga_utama ? 1 : 0}" name="model.price[${harga_index - 1}].isMain"/>
                                </div>
                            </div>
                        #{/list}
                    #{/if}

                    #{else }
                        <div class="form-group">
                            <label class="col-sm-2 control-label">&{"unggah_file_harga.label"}</label>
                            <div class="col-sm-8">
                                <button class="btn btn-md btn-info" type="button" id="download"><i class="fa fa-download"></i> &{"template_unduh.label"}</button>
                                <button class="btn btn-md btn-primary" type="button" onclick="$('#harga_upload').click();"><i class="fa fa-upload"></i> &{"unggah_file.label"}</button>

                                <button id="file-harga" type="button" class="btn btn-primary" style="vertical-align: middle;margin-inside: 1em">&{'lihat.label'}</button>
                                <input type="file" id="harga_upload" style="display:none">
                                <input id="harga-json" name="model.hargaJson" type="hidden" required />
                            </div>
                        </div>
                    #{/else}

                    #{if komoditas.perlu_ongkir && !komoditas.isRegency()}

                        <div class="form-group">
                            <label class="col-sm-2 control-label">&{"unggah_file_ongkir.label"}</label>
                            <div class="col-sm-8">
                                <a href="#" class="btn btn-info" id="downloadTemplateOngkir"><i class="fa fa-download"></i> &{"template_unduh.label"}</a>
                                <button class="btn btn-md btn-primary" type="button" onclick="$('#ongkir_upload').click();"><i class="fa fa-download"></i> &{"unggah_file.label"}</button>

                                <button id="file-ongkir" type="button" style="vertical-align: middle;margin-inside: 1em" class="btn btn-primary">&{'lihat.label'}</button>
                                <input type="file" id="ongkir_upload" style="display:none">
                                <input id="ongkir-json" name="model.ongkirJson" type="hidden" />
                            </div>
                        </div>

                    #{/if}
*{                    #{if produk?.id != null}}*
*{                        <br/>}*
*{                        <br/>}*
*{                        <h4>&{'daftar_riwayat_harga.label'}</h4>}*
*{                        <hr/>}*
*{                        #{if checkedLocations!=null && checkedLocations.size() > 0}}*
*{                            <select id="locationSelect">}*
*{                                #{list checkedLocations, as:'checkedLocation'}}*
*{                                    <option value="${checkedLocation.key}">${checkedLocation.value}</option>}*
*{                                #{/list}}*
*{                            </select>}*
*{                        #{/if}}*
*{                        <div style="overflow-x: auto">}*
*{                            <table class="table table-striped" id="table-riwayat-harga">}*
*{                                <thead>}*
*{                                <tr>}*
*{                                    <th class="header-center">&{'tanggal.label'}</th>}*
*{                                    <th class="header-center">&{'kurs.label'}</th>}*
*{                                    #{list atributHargaList, as:'harga'}}*
*{                                        <th class="header-center">${harga.label_harga}</th>}*
*{                                    #{/list}}*
*{                                </tr>}*
*{                                </thead>}*
*{                                #{if komoditas?.isNational()}}*
*{                                    <tbody id="tBody-riwayat-harga">}*
*{                                        #{list riwayatProdukHarga, as:'item'}}*
*{                                        <tr>}*
*{                                            <td class="column-center">${item.key}</td>}*
*{                                            <td class="column-center">${item.value.get(0).nama_kurs}</td>}*
*{                                            #{list atributHargaList, as:'attr'}}*
*{                                                <td class="column-center">${produk.getHargaByAttr(attr.id, item.value)}</td>}*
*{                                            #{/list}}*
*{                                        </tr>}*
*{                                        #{/list}}*
*{                                    </tbody>}*
*{                                #{/if}}*
*{                                #{else}}*
*{                                    #{list riwayatProdukHargaPerLokasi, as:'item'}}*
*{                                        <tbody class="tBody-riwayat-harga" id="tBody-riwayat-harga-${item.key}">}*
*{                                            #{list item.value, as:'row'}}*
*{                                            <tr>}*
*{                                                <td class="column-center">${row.tanggal}</td>}*
*{                                                <td class="column-center">${row.kurs}</td>}*
*{                                                #{list atributHargaList, as:'attr'}}*
*{                                                    <td class="column-center">${produk.getHargaByAttrAndLocation(attr.id, row.tanggal, item.value)}</td>}*
*{                                                #{/list}}*
*{                                            </tr>}*
*{                                            #{/list}}*
*{                                        </tbody>}*
*{                                    #{/list}}*
*{                                #{/else}}*
*{                            </table>}*
*{                        </div>}*
*{                        <br/>}*
*{                        <br/>}*
*{                    #{/if}}*
                </div>
            </div>
        </div>
    </div>
    <input type="hidden" id="pmbid" name="pmbid" value="${pmb?.id}">
    <input type="hidden" id="ids" name="ids" value="${ids}">
    <input type="hidden" id="kelas_hargas" name="model.kelas_harga" value="${komoditas?.kelas_harga}">

    <input type="hidden" id="checked-locations" name="model.checkedLocations" value="${checked_Locations}">
    #{if komoditas.isNational()}
        <input type="hidden" id="xls-json" name="model.xlsJson" value="${produk?.produkHarga?.harga_xls_json}"/>
    #{/if}
    #{else}
        <input type="hidden" id="xls-json" name="model.xlsJson" value="${produkHarga?.harga_xls_json}"/>
    #{/else}
#{/form}
</div>

<div class="modal fade" id="myModal" role="dialog">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal">&times;</button>
                <h4 class="modal-title">&{'daftar_harga.label'}</h4>
            </div>
            <div class="modal-body">
                <div class="col-xs-12">
                    <div class="dataTables_paginate paging_full_numbers" >
                        Go to
                        <input type="text" id="jump" style="width: 30px;">
                    </div>
                </div>
                <table class="table table-hover">
                    <thead class="price-header">

                    </thead>
                    <tbody class="price-data-list">

                    </tbody>
                </table>
                <div class="col-xs-7">
                    <div class="dataTables_paginate paging_full_numbers" >
                        <ul class="pagination pagination-sm">
                            <li class="paginate_button previous button-prev" data-page="0">
                                <a href="#">&{'sebelumnya.label'}</a></li>
                            <li class="paginate_button" data-page="0">
                                <a href="#" class="page-counter">Page 1</a>
                            </li>
                            <li class="paginate_button next button-next" data-page="0">
                                <a href="#">&{'berikutnya.label'}</a></li>
                        </ul>
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">&{'close'}</button>
            </div>
        </div>
    </div>
</div>

#{set 'moreScripts'}
<script type="text/javascript" src="@{'public/javascripts/toast/jquery.toast.min.js'}"></script>
<script type="text/javascript" src="@{'public/javascripts/download-harga-util.js'}"></script>
<script type="text/javascript" src="@{'public/javascripts/upload-harga-util.js'}"></script>
<script type="text/javascript" src="@{'public/javascripts/bootstrap-notify.min.js'}"></script>
<script type="text/javascript">
    //define variabel
    var tempJson = {};
    var params = {};
    var xlsJson = {};
    var checkLocations = {};
    const MODE_PRICE = 'price';
    const MODE_COST = 'cost';
    var mode = 'price';

    var page = 0;
    var prevButton = $('.button-prev');
    var nextButton = $('.button-next');

    //explain variabel and set
    params['getKabByProvUrl'] = '@{controllers.katalog.ProdukCtr.getKabByProv()}';
    params['getAllKabAllProv'] = '@{controllers.katalog.ProdukCtr.getAllKabAllProv()}';
    params['priceClass'] = '${komoditas?.kelas_harga}';
    params['downloadTemplateHarga'] = {};
    params['downloadTemplateHarga']['requiredDeliveryCost'] = ${komoditas?.perlu_ongkir};
    params['downloadTemplateHarga']['atributHarga'] = ${atributHargaJson.raw()};
    params['downloadTemplateHarga']['namaPenyedia'] = $("#namaPenyedia").html();
    params['atributHarga'] = ${atributHargaJson.raw()};

    tempJson[MODE_PRICE] = [];
    tempJson[MODE_COST] = [];

    xlsJson[MODE_PRICE] = [];
    xlsJson[MODE_COST] = [];

    // prepare untuk menampilkan list ongkir exiting
    var ongkir = JSON.parse('${produk?.ongkir}'.replace(/&quot;/g,'"'));
    var provKab = JSON.parse('${new com.google.gson.Gson().toJson(provKab)}'.replace(/&quot;/g,'"'));

    function showToastSuccess(message) {
        jQuery.toast({
            heading: 'Please wait',
            text: message,
            position: 'bottom-center',
            stack: false,
            icon: 'success',
            hideAfter: 10000
        })
    }


    function setToXlsJson() {
        $("#xls-json").val(JSON.stringify(xlsJson));
    }

    jQuery(document).ready(function () {

        //onclick button download excell
        $(document).on("click","#downloadTemplateOngkir", function(){
            //var checkedItems = $(".wilJualItems:checkbox:checked");
            var kelasHarga = params.priceClass;
            params['downloadTemplateHarga']['namaProduk'] = $("#namaProduk").val();
            var ids = $('#ids').val();
            if(kelasHarga == 'provinsi'){
                // checkedItems.each(function () {
                //     var item = $(this);
                //     var provInfo = {};
                //     provInfo['provId'] = item.val();
                //     provInfo['provName'] = item.attr("provname");
                //     ids.push(provInfo);
                // });
                $.ajax({
                    type:'POST',
                    url: params.getKabByProvUrl,
                    dataType:'json',
                    data :{
                        checkedProv:JSON.stringify(ids)
                    },
                    success:function(result){
                        // console.log(result);
                        generateXlsxOngkir(result, kelasHarga, params.downloadTemplateHarga);
                    }
                });
            } else {
                //getAllKabAllProv
                //var obj_parameter = {};
                //obj_parameter["namaProduk"] = $("#namaProduk").val();
                //obj_parameter["namaPenyedia"]= $("#namaPenyedia").html();

                //@ var url = "{katalog.ProdukCtr.downloadTemplateOngkir()}" + createQueryString(obj_parameter);
                //window.location = url;
                showToastSuccess('Please wait , generate  excell all kab. . . .');
                $.ajax({
                    type:'POST',
                    url: params.getAllKabAllProv,
                    dataType:'json',
                    data :{},
                    success:function(result){
                        // console.log(result);
                        generateXlsxOngkir(result, kelasHarga, params.downloadTemplateHarga);
                    },
                    done: function () {
                        alert("done");
                    },error: function () {
                        setTimeout(location.reload.bind(location), 1000);
                    },
                    failed: function(){
                        setTimeout(location.reload.bind(location), 1000);
                    }
                });
            }
        });

        $("#download").click(function() {
            //var checkedItems = $(".wilJualItems:checkbox:checked");
            var kelasHarga = params.priceClass;
            params['downloadTemplateHarga']['namaProduk'] = $("#namaProduk").val();
            var ids = JSON.parse($('#ids').val());
            var result1 = new Array();
            ids.forEach(function (obj) {
                result1.push(obj);
            });


            // if(kelasHarga == 'kabupaten'){
            //     checkedItems.each(function () {
            //         var item = $(this);
            //         var kabInfo = new Array();
            //         kabInfo['kabId'] = item.val();
            //         kabInfo['kabName'] = item.attr("kabName");
            //         kabInfo['provName'] = item.attr("provName");
            //         ids.push(kabInfo);
            //     });
            // } else {
            //     checkedItems.each(function () {
            //         var item = $(this);
            //         var kabInfo = new Array();
            //         kabInfo['kabId'] = item.val();
            //         kabInfo['provName'] = item.attr("provName");
            //         ids.push(kabInfo);
            //     });
            // }
            generateXlsx(result1, kelasHarga, params.downloadTemplateHarga);
        });

        function openModal() {
            jQuery('#myModal').modal({
                backdrop: 'static',
                keyboard: false
            });
        }

        function changePricePagination(view) {
            view.click(function () {
                var currentPage = parseInt(view.attr('data-page'));
                var data = tempJson[mode][currentPage];
                if(mode == MODE_COST && tempJson[mode].length == 0 && ongkir.length > 0) data = ongkir.slice(currentPage * 10, (currentPage * 10) + 10);
                if (data) {
                    changePage(currentPage);
                }
            });
        }

        function parse(json) {
            return json !== '' ? JSON.parse(json) : [];
        }

        function split(json) {
            var data = parse(json);
            return splitter(data);
        }

        function splitter(data) {
            var temporary = [];
            var i, j, chunk = 10;
            if (data.length > 0) {
                for (i = 0, j = data.length; i < j; i += chunk) {
                    temporary[i/10] = data.slice(i, i + chunk);
                }
            }
            return temporary;
        }

        function generateHeaderTemplate() {
            var template = '<tr>';
            if (tempJson[mode][0] !== undefined && tempJson[mode][0].length > 0 && tempJson[mode][0].length > 0) {
                var model = tempJson[mode][0][0];
                for (var i in model) {
                    var value = model[i];
                    var className = !isNaN(value) ? 'header-right' : 'header-left';
                    template += '<th class="' + className + '">' + i + '</th>';
                }
            }
            else if(mode == MODE_COST && ongkir.length > 0){ // Ipeng - 21-03-2018 : template header exiting ongkir
                template += '<th>Provinsi</th><th>Kabupaten</th><th>Ongkir</th>';
            }
            template += '</tr>';
            $('.price-header').html(template);
        }

        function changePageIndex(page) {
            var tempArraySize = tempJson[mode].length === 0 ? (ongkir.length > 0 && mode == MODE_COST ? Math.ceil(ongkir.length / 10) - 1 : 0) : tempJson[mode].length - 1;
            if (page >= 0 && page <= tempArraySize) {
                var prev = page - 1;
                var next = page > tempArraySize ? tempArraySize : page + 1;
                prevButton.attr('data-page', prev);
                nextButton.attr('data-page', next);
                if (prev >= 0)  {
                    prevButton.removeClass('disabled');
                } else {
                    prevButton.addClass('disabled');
                }

                if (next > tempArraySize) {
                    nextButton.addClass('disabled');
                } else {
                    nextButton.removeClass('disabled');
                }
                $('.page-counter').html('Page ' + (page + 1) + " of " + (tempArraySize + 1));
            }
        }

        function changePage(page) {
            var template = '';
            if (tempJson[mode][page]) {
                template = generateContentTemplate(page);
            }
            else if(mode == MODE_COST && ongkir.length > 0){
                template = generateContentTemplateExitingOngkir(page);
            }
            $('.price-data-list').html(template);
            changePageIndex(page);
        }

        function generateContentTemplate(page) {
            var content = '';
            for (var i in tempJson[mode][page]) {
                var template = '<tr>';
                var model = tempJson[mode][page][i];
                for (var k in model) {
                    var value = model[k];
                    var className;
                    if (!isNaN(value)) {
                        value = Number(value).toLocaleString('id');
                        className = 'column-right';
                    } else {
                        className = 'column-left';
                    }
                    template += '<td class="' + className + '">' + value + '</td>';
                }
                template += '</tr>';
                content += template;
            }
            return content;
        }

        function generateContentTemplateExitingOngkir(page){
            var content = '';
            var start = page * 10;
            var end = start + 10;
            var records = ongkir.slice(start,end);
            $(records).each(function(idx,rec){
                var template = '<tr>';
                var kab = provKab.filter(function(item) { return item.kabId === rec.kabupatenId; })[0];
                if(kab != undefined) template += '<td class="text-center">'+kab.provName+'</td><td class="text-center">' + kab.kabName  + '</td>';
                else template += '<td></td><td></td>';
                template += '<td class="text-right">'+ rec.ongkir.toLocaleString() +'</td>';

                template += '</tr>';
                content += template;
            });
            return content;
        }

        $('#file-harga').click(function () {
            mode = MODE_PRICE;
            openModal();
        });

        $('#file-ongkir').click(function () {
            mode = MODE_COST;
            openModal();
        });

        jQuery('#myModal').on('show.bs.modal', function (e) {
            generateHeaderTemplate();
            changePage(page);
        });


        $(document).on('change', '#harga_upload', function (e) {
            $.showLoading();
            try{
                douploadHarga(e, "file-harga","harga-json", function (data) {
                    tempJson.price = [];
                    xlsJson.price = [];
                    xlsJson.price = parse(data.json);
                    //set ke field, untuk simpan data harga
                    setToXlsJson()
                    tempJson.price = split(data.json);
                    emptyExcel = data.totalEmpty;
                });
                $(this).val("");
            }catch (e) {}
            setTimeout(function () {
                $.hideLoading();
            }, 1000);
        });

        function updateTabelRiwayatHarga(){
            var locationVal=$("#locationSelect").val();
            $(".tBody-riwayat-harga").hide();
            $("#tBody-riwayat-harga-"+locationVal).show();
        }

        $(document).on('change', '#ongkir_upload', function (e) {
            $.showLoading();
            try{

                douploadHarga(e, "file-ongkir","ongkir-json", function (data) {
                    tempJson.cost = [];
                    xlsJson.cost = [];
                    xlsJson.cost = parse(data.json);
                    //set ke field, untuk simpan data harga
                    setToXlsJson();
                    tempJson.cost = split(data.json);
                    emptyExcel = data.totalEmpty;
                });
                $(this).val("");
            }catch (e) {
            }
            setTimeout(function () {
                $.hideLoading();
            }, 1000);
        });

        changePricePagination(prevButton);
        changePricePagination(nextButton);

        $(document).on("change","#locationSelect", updateTabelRiwayatHarga);

        updateTabelRiwayatHarga();
    });
</script>
#{/set}